
(include "lib/core.scm")
(include "lib/frb.scm")
(include "lib/string.scm")
(include "lib/io.scm")
(include "lib/pair.scm")
(include "lib/vector.scm")
(include "lib/symbol.scm")

(define (lex producer consumer)

  (let ((current '())
	(final #f)
	(last-final #f)
	)

      (define (build-token final)
	(consumer (cons (car final) (list->string (reverse current))))
	(set! current '())
	(set! last-final #f))

      ;; defines the <step> function (DFA) from the lexer generator
      (include "tests/step5.scm")

      (let block-loop ((s (producer))
		       (state 0)
		       (slen 0)
		       (ch #f)
		       )
	(set! slen (string-length s))
	(print-string "got bytes in block-loop: ") (%printn slen)
	(if (= slen 0)
	    (if last-final (build-token last-final) #f)
	    (let char-loop ((i 0))
	      (cond ((= i slen)
		     (block-loop (producer) state 0 #f))
		    (else
		     (set! ch (string-ref s i))
		     (set! state (step ch state))
		     (set! final (vector-ref finals state))
		     (cond ((and final (cdr final))
			     ;; single-char final state
			    (build-token final)
			    (set! state 0)
			    (char-loop (+ i 1)))
			   ((and last-final (not final))
			    ;; multiple-char, must wait until transition out...
			    (build-token last-final)
			    (set! state 0)
			    (char-loop i))
			   (else
			    (set! last-final final)
			    (set! current (cons ch current))
			    (char-loop (+ i 1))))))
	      )))
      ))

(define end-of-file '(end-of-file . end-of-file))

(define (make-lex-generator filename)
  (make-generator
   (lambda (consumer)
     (lex ((buffered-file (open filename 0) 2048) 'read-buffer) consumer)
     (let forever () (consumer end-of-file) (forever))
     )))

